#include "xbp.ch"
#include "dll.ch"
#include "gra.ch"
#include "common.ch"
#include "xbpdev.ch"
#include "appevent.ch"
#include "xbppdf.ch"
#pragma  library("xppPDF1.lib")
#pragma library("ot4xb.lib")

PROCEDURE AppSys
RETURN


PROCEDURE MAIN
parameter arq


aSize := { 590, 780 }
aPos  := { 0, 50 }
oDlg := xbpDialog():New(,,aPos, {612, 822} )
oDlg:Create()

oPs := oDlg:DrawingArea:LockPS()
oFont := xbpFont():New( oPs )
oFont:Create('24.Times New Roman')

oPdf := xbppdf():New()
oPdf:Create("gra.pdf")
oPdf:NewPage( , , , , ,1 )

report( oPdf )
oPdf:enddoc(.t.)

report( oPs )

oDlg:SetInputFocus()
SetAppFocus(oDlg)
nEvent := 0
do while nEvent <> xbeP_Close
	nEvent := AppEvent( @mp1, @mp2, @obr )
	obr:handleEvent( nEvent, mp1, mp2 )
	if nEvent = xbeP_Keyboard
		exit
	endif
Enddo

return

Function Report( oPs )

	aAttra := array(GRA_AA_COUNT)

	aAttra[GRA_AA_COLOR] := GRA_CLR_WHITE
	GraSetAttrArea( oPs , aAttra )
	GraBox( oPs , {10,10}, aSize, GRA_OUTLINEFILL)

	aAttra[GRA_AA_COLOR] := GRA_CLR_YELLOW
	GraSetAttrArea( oPs , aAttra )
	GraBox( oPs , {100, 100}, {512, 692}, GRA_OUTLINEFILL)

	GraSetFont( oPs , oFont )
	GraSetColor( oPs , GRA_CLR_BLUE )
	GraStringAt( oPs , {230, 400}, "Hello world!" )

RETURN(.t.)


Function ReportPDF

	aAttra := array(GRA_AA_COUNT)

	aAttra[GRA_AA_COLOR] := GRA_CLR_WHITE
	oPdf:GraSetAttrArea( aAttra )
	oPdf:GraBox( {10, 10}, aSize, GRA_OUTLINEFILL)

	aAttra[GRA_AA_COLOR] := GRA_CLR_YELLOW
	oPdf:GraSetAttrArea( aAttra )
	oPdf:GraBox( {100, 100}, {512, 692}, GRA_OUTLINEFILL)

	oPdf:GraSetFont(  oFont )
	oPdf:GraSetColor( GRA_CLR_BLUE )
	oPdf:GraStringAt( {230, 400}, "Hello world!" )

RETURN(.t.)


#include "xbp.ch"
#include "dll.ch"
#include "gra.ch"
#include "common.ch"
#include "xbpdev.ch"
#include "appevent.ch"
#pragma  library("xppPDF1.lib")
#pragma library("ot4xb.lib")

/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGSetAttrArea( oObj, aAttrib )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraSetAttrArea( oObj, aAttrib )
else
	Atrib := oObj:GraSetAttrArea( aAttrib )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGSetAttrLine( oObj, aAttrib )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraSetAttrLine( oObj, aAttrib )
else
	Atrib := oObj:GraSetAttrLine( aAttrib )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGSetAttrString( oObj, aAttrib )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraSetAttrString( oObj, aAttrib )
else
	Atrib := oObj:GraSetAttrString( aAttrib )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGSetAttrMarker( oObj, aAttrib )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraSetAttrMarker( oObj, aAttrib )
else
	Atrib := oObj:GraSetAttrMarker( aAttrib )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGBox( oObj, aStart, aEnd, nFill, nHRadius, nVRadius )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraBox( oObj, aStart, aEnd, nFill, nHRadius, nVRadius )
else
	Atrib := oObj:GraBox( aStart, aEnd, nFill, nHRadius, nVRadius )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGLine( oObj, aStart, aEnd )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraLine( oObj, aStart, aEnd )
else
	Atrib := oObj:GraLine( aStart, aEnd )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGStringAt( oObj, aStart, cText )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraStringAt( oObj, aStart, cText )
else
	Atrib := oObj:GraStringAt( aStart, cText )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGSetFont( oObj, oFont )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraSetFont( oObj, oFont )
else
	Atrib := oObj:GraSetFont( oFont )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGSetColor( oObj, nFclr, nBclr )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraSetColor( oObj, nFclr, nBclr )
else
	Atrib := oObj:GraSetColor( nFclr, nBclr )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGMarker( oObj, aStart )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraMarker( oObj, aStart )
else
	Atrib := oObj:GraMarker( aStart )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGPos( oObj, aStart )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraPos( oObj, aStart )
else
	Atrib := oObj:GraPos( aStart )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGPathBegin( oObj )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraPathBegin( oObj )
else
	Atrib := oObj:GraPathbegin( )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGPathEnd( oObj, lClose )
LOCAL Atrib
DEFAULT lClose to .f.

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraPathEnd( oObj, lClose )
else
	Atrib := oObj:GraPathEnd( lClose )
endif

Return( Atrib )




/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGPathFill( oObj )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraPathFill( oObj )
else
	Atrib := oObj:GraPathFill( )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGPathOutline( oObj )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraPathoutline( oObj )
else
	Atrib := oObj:GraPathOutline( )
endif

Return( Atrib )



/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGArc( oObj, aCenter, nRadius, aEllipse, nStartAngle, nSweepAngle, nFill )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraArc( oObj, aCenter, nRadius, aEllipse, nStartAngle, nSweepAngle, nFill )
else
	Atrib := oObj:GraArc( aCenter, nRadius, aEllipse, nStartAngle, nSweepAngle, nFill )
endif

Return( Atrib )


/////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////
FUNCTION PGQuerytextBox( oObj, cText )
LOCAL Atrib

if upper( oObj:ClassName() ) <> "XBPPDF"
	Atrib := GraQueryTextBox( oObj, cText )
else
	Atrib := oObj:GraQueryTextBox( cText )
endif

Return( Atrib )
