#include "dll.ch"
#include "gra.ch"
#include "xbp.ch"
#include "common.ch"
#include "xbpdev.ch"
#include "appevent.ch"
#pragma  library("xpppdf1.lib")

PROCEDURE MAIN

cor_vermelho := GraMakeRGBColor({255,96,96})
cor_amarelo  := GraMakeRGBColor({255,255,128})
cor_azul     := GraMakeRGBColor({64,208,255})
cor_verde    := GraMakeRGBColor({96,255,96})
cor_turquesa := GraMakeRGBColor({64,128,128})

	fl := 'Demo.Pdf'
	use parts
	
	pdf := xbppdf():New(,.f.)
	dc  := pdf:Create( fl )

*	pdf:lDebug := .t.
*	pdf:Password( "test", "" )
*	pdf:Encryption( 2, 5 )
*	pdf:Permission( 16+32 )
*	pdf:lFixed := .f.


	pg  := pdf:newpage(XBPPRN_FORM_LETTER)

	pdf:Font('8.Courier New')
	pdf:text(0.2,65,"LineWidth 1.5")

	pdf:Font('10.Symbol')
	pdf:text(1,1,"asdkjoiau8r93q4roi343sfadlkfadsfmĿ")
	
	pdf:Font('8.5 verdana underscore')
	pdf:Text(15,5,'Verdana underscore')

	pdf:GraSetfont('8.Courier New')
	pdf:linewidth(0,0)

	atribm := array(GRA_AM_COUNT)
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_CROSS
	pdf:GrasetAttrMarker( atribm )
	pdf:Graline({1,1},{50,1})
	pdf:GraMarker( {,} )
	pdf:text(0.2,52,"LineWidth 0")
	pdf:linewidth(0.5,0)
	pdf:Graline({1,2},{50,2})
	pdf:GraMarker(NIL )
	pdf:text(1.2,52,"LineWidth 0.5")
	pdf:linewidth(1,0)
	pdf:Graline({1,3},{50,3})
	pdf:GraMarker( {NIL,NIL} )
	pdf:text(2.2,52,"LineWidth 1")
	pdf:linewidth(1.5,0)
	pdf:Graline({1,4},{50,4})
	pdf:GraMarker( )
	pdf:text(3.2,52,"LineWidth 1.5")

	pdf:Font('8.Courier New')
	pdf:text(4.2,52,"LineWidth 1.5")
		
	pdf:GraSetfont('10.Courier New Bold')

	aAtrib := array( GRA_AA_COUNT )
	aAtrib[GRA_AA_COLOR] := GRA_CLR_RED
	aAtrib[GRA_AA_BACKCOLOR] := GRA_CLR_YELLOW
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DENSE8
	pdf:GraSetAttrArea( aAtrib )

	aAtribl := array(GRA_AL_COUNT)
	aAtribl[GRA_AL_WIDTH] := GRA_LINEWIDTH_THICK
	pdf:GraSetAttrLine( aAtribl )

	pdf:GraBox( {20,5},{30,10}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({22,8},"DENSE 8")

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DENSE6
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {20,12},{30,17}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({22,15},"DENSE 6")

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DENSE4
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {20,19},{30,24}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({22,22},"DENSE 4")
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DENSE2
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {20,26},{30,31}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({22,29},"DENSE 2")
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_SOLID
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {20,33},{30,38}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({22,36},"SOLID")
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_HALFTONE
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {20,40},{30,45}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({22,42},"HALFTONE")


	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_VERT
	pdf:GraSetAttrArea( aAtrib )

	aAtribl := array(GRA_AL_COUNT)
	aAtribl[GRA_AL_WIDTH] := GRA_LINEWIDTH_THICK
	pdf:GraSetAttrLine( aAtribl )

	pdf:GraBox( {35,5},{45,10}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({37,8},"VERT")

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_HORIZ
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {35,12},{45,17}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({37,15},"HORIZ")

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG1
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {35,19},{45,24}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({37,22},"DIAG 1")
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG2
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {35,26},{45,31}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({37,29},"DIAG 2")
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG3
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {35,33},{45,38}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({37,36},"DIAG 3")
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG4
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraBox( {35,40},{45,45}, GRA_OUTLINEFILL, 1, 1 )
	pdf:GraStringAt({37,42},"DIAG 4")

	pdf:GraSetfont('10.Courier New')

	aAtribl[GRA_AL_TYPE] := 4
	pdf:GraSetAttrLine( aAtribl )
	pdf:GraLine( {50,15},{40,15} )
	pdf:GraStringAt( {40,5}, "teste" )

	pdf:LineWidth( 1 )
	pdf:LineType( {1} )
	aAtribs := array(GRA_AS_COUNT)
	aAtribs[GRA_AS_ANGLE] := {cos(15*3.141592/180),sin(15*3.141592/180)}
	pdf:GraSetAttrString( aAtribs )
	pdf:GraSetColor( GRA_CLR_BLUE )
	pdf:TextBox( {50,20},{75,19}, " Text In A Box With Dotted Border ", .t.,9)

	pdf:GraStringAt( {50,23}, " Angled Text With GraStringAt ")
	pdf:Line( 24.2,50, 20.05, 74 )
	pdf:rtext( 25, 50, " Angled Text With rText ", 15)
	pdf:Line( 26.2,50, 22.05, 74 )

	aAtribs[GRA_AS_ANGLE] := {1,0}
	pdf:GraSetAttrString( aAtribs )
	pdf:GraSetColor( GRA_CLR_BLUE )
	pdf:TextBox( {50,12},{75,11}, " Text In A Box With Dotted Border ", .t.,9)

	pdf:LineType({0})
	pdf:Linecolor(1)
	pdf:BoxColor(1,1)
	pdf:GraPathBegin()
	pdf:GraPos({15,45})
	pdf:GraArc({10,40}, 5, , 0, 180)
	pdf:GraLine( {10,40}, {20,40} )
	pdf:GraLine( {20,40}, {20,45} )
	pdf:GraLine( {20,45}, {10,45} )
	pdf:GraPathEnd( .t. )
	pdf:GraPathOutline()
*	pdf:GraPathFill()





	aAtribl[GRA_AL_COLOR] := GRA_CLR_BLACK
	pdf:GraSetAttrLine( aAtribl )
	pdf:LineType({0})
	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG3
	aAtrib[GRA_AA_COLOR] := 5
	aAtrib[GRA_AA_BACKCOLOR] := NIL
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraArc( {10,50}, 5, ,0, 90 )

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG4
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraArc( {10,50}, 5, ,90,90, GRA_OUTLINEFILL)

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG1
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraArc( {10,50}, 5, ,180, 90, GRA_FILL )

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_DIAG2
	pdf:GraSetAttrArea( aAtrib )
	pdf:Linecolor(4)
	pdf:BoxColor(4,4)
	pdf:GraArc( {10,50}, 5, ,270, 90, GRA_OUTLINEFILL)

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_HORIZ
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraSetColor(GRA_CLR_BLUE)
	pdf:GraArc( {50,50}, 5, {2,0,0,1},0,45, GRA_FILL)

	aAtrib[GRA_AA_SYMBOL] := GRA_SYM_VERT
	pdf:GraSetAttrArea( aAtrib )
	pdf:GraSetColor(GRA_CLR_RED)
	pdf:GraArc( {50,50}, 5, {2,0,0,1}, 180, 180, GRA_OUTLINE)

	
	atribm := array(GRA_AM_COUNT)
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_CROSS
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {40,50} )
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_PLUS
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {45,50} )
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_DIAMOND
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {50,50} )
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_SQUARE
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {55,50} )

	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_SOLIDDIAMOND
	atribm[GRA_AM_BOX] := {1,1}
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {50,53} )

	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_SOLIDSQUARE
	atribm[GRA_AM_BOX] := {1.5,1.5}
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {55,53} )
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_DOT  
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {40,53} )
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_SMALLCIRCLE
	atribm[GRA_AM_BOX] := {2,2}
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {45,53} )
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_SIXPOINTSTAR
	atribm[GRA_AM_BOX] := {2.5,2.5}
	pdf:GrasetAttrMarker( atribm )
	pdf:GraMarker( {60,50} )
	atribm[GRA_AM_SYMBOL] := GRA_MARKSYM_EIGHTPOINTSTAR
	atribm[GRA_AM_BOX] := {3.5,3.5}
	pdf:GrasetAttrMarker( atribm )
	pdf:GraPos( {60,53} )
	pdf:GraLine( {50,53}, {60,53})
	pdf:GraMarker( NIL )


	pdf:GraBox( {3,50},{35,60}, GRA_OUTLINE, 1, 1 )
	pdf:image(50,3,60,35,"ablue.bmp")
	
//////////////////////////////   PAGE 2   //////////////////////////////////

	pg  := pdf:newpage(XBPPRN_FORM_LETTER)

	pdf:BoxColor()
	root := pdf:OutLine( 1, 0, "Order Sample" )
*	pdf:chinesefonts(.t.)

	pdf:Box( 0, 0, 65, 79 )

	pdf:Image( 0, 2, 6, 77, "Logo.JPG", .t. )

	pdf:LineWidth( 2 )
	pdf:LineType( {5} )
	pdf:Box( 6, 2, 10, 77, 10)
	pdf:TextColor( GRA_CLR_BLUE )
	pdf:font( '14.Arial Bold' )
	pdf:Text( 7, 10, "Parts Price List " + fl)
	pdf:Text( 7, 60, dtoc(date()) )

	pdf:LineWidth( 1 )
	pdf:LineType( {0} )
	pdf:Box( 12, 2, 50, 77 )
	pdf:Line( 12, 13, 50, 13 )
	pdf:Line( 12, 54, 50, 54 )
	pdf:Line( 12, 65, 50, 65 )

	pdf:TextColor( GRA_CLR_BLACK )
	pdf:font( '10.Courier New Bold',,.t. )
	pdf:text( 12,  3, "Prt Nmbr" )
	pdf:text( 12, 14, "Descricao" )
	pdf:text( 12.4, 55, " Available" )
	pdf:text( 12.4, 66, "     Price" )
	pdf:Line( 14, 2, 14, 77 )
	pdf:font( '10.Courier New' )

	go top
	line := 14
	do while .not. eof()
		pdf:Text( line, 3, number )
		pdf:Text( line, 14, descrip )
		pdf:Text( line, 57, transform( qt, '###,###') )
		pdf:Text( line, 66, transform( price, '###,###.##') )
		line = line + 1
		skip
	enddo

	NL=CHR(13)+CHR(10)
	text='I have'+NL+'problem with'+NL+'multiline mText.'
	pdf:mText(30,20,text)

	pdf:BoxColor( GRA_CLR_RED )
	pdf:Box( 52, 6, 57, 73, 25 )
	pdf:TextColor( GRA_CLR_DARKBLUE )
	pdf:font( '20.Courier New Bold',,.t. )
	pdf:Text( 52.5,  9, 'Demo Created by Softsupply Informatica' )
	pdf:TextColor( GRA_CLR_BLACK )
	pdf:font( '8.Courier New Italic' )
	pdf:Text( 54.0,  9, 'Contact :' )
	pdf:Text( 54.0, 44, 'eMail :' )
	pdf:Text( 55.0,  9, 'Fone    :' )
	pdf:Text( 55.0, 44, 'Fax   :' )
	pdf:font( '12.Courier New' )
	pdf:Text( 54, 15, 'Edgar Borger' )
	pdf:Text( 55, 15, '(5511) 3159-1997' )
	pdf:Text( 55, 49, '(5511) 3255-5224' )
	pdf:TextColor( GRA_CLR_BLUE )
	pdf:Text( 54, 49, 'eborger@terra.com.br' )

//////////////////////////////   PAGE 3   //////////////////////////////////

	pdf:NewPage()
	pg1 := pdf:OutLine( 1, , "Miscellaneous" )
	pdf:Font('14.Courier New')
	pdf:BoxColor( GRA_CLR_DARKBLUE )
	pdf:box(04,30,19,50)
	pdf:box(19,30,24,50)
	pdf:Line(04,40,19,40)
	pdf:Line(12,30,12,50)
	nl := chr(13)+chr(10)
	pdf:TextColor( GRA_CLR_BLUE )
	txt := "This"+nl+"text"+nl+"is"+nl+"left"+nl+"aligned"
	pdf:mText(05,40.5,txt,0)
	pdf:TextColor( GRA_CLR_RED )
	txt := "This"+nl+"text"+nl+"is"+nl+"right"+nl+"aligned"
	pdf:mText(05,39.5,txt,1)
	pdf:TextColor( GRA_CLR_GREEN )
	txt := "This"+nl+"text"+nl+"is"+nl+"center"+nl+"aligned"
	pdf:mText(13,40,txt,2)
	pdf:TextColor( GRA_CLR_DARKGREEN )
	txt := "This text"+nl+"is a justified"+nl+"aligned text"
	pdf:mText(20,34,txt,3)

	pdf:LineWidth(4)
	pdf:BoxColor( GRA_CLR_RED, GRA_CLR_BLUE )
	pdf:Box(12,60,20,75)
	pdf:TextColor( GRA_CLR_YELLOW )
	txt := "This"+nl+"text"+nl+"is"+nl+"right"+nl+"aligned"
	pdf:mText(13,74.5,txt,1)

	pdf:OutLine( 30, pg1, "Underscore" )
	pdf:TextColor( GRA_CLR_DARKPINK )
	pdf:Font('14.Courier New Underscore')
	pdf:Text(30,45,"This text is underscored")

	pdf:OutLine( 40, pg1, "Barcode" )
	pdf:TextColor( GRA_CLR_BLACK )
	pdf:Font('12.Courier New')
	pdf:Text(40,55,'Barcode usage')
	pdf:FontDef( 'Barcode', 'barcode.ttf', .t. )
	pdf:Font('10.Barcode')
	pdf:Text(43,56,'*12345678*')
	
	pdf:Font('14.Courier New')
	pdf:LineWidth(2)
	pdf:Shape({{20,10}, {25,12}, {28,9}, {32,42}, {35,38}, {30,33}, {22,25}}, GRA_CLR_BLUE, -1, GRA_CLR_YELLOW)
	pdf:Text(23,12,"Shape Sample")

	pdf:Text(38,10,"Image Sample")
	pdf:Image(40,10,51,31,"aBlue.bmp",.f.)
	pdf:Image(40,40,51,71,"aBlue.bmp",.t.)

	pdf:OutLine( 55, pg1, "Colors" )
	pdf:LineWidth(1)
	pdf:Font('12.Courier New Bold')
	pdf:text(55,5,'Alaska GRA_CLR_...')
	pdf:Font('10.Courier New Bold')
	cores := {"WHITE","BLACK","BLUE","RED","PINK","GREEN","CYAN","YELLOW","DARKGRAY","DARKBLUE","DARKRED","DARKPINK","DARKGREEN","DARKCYAN","BROW","PALEGRAY"}
	for i = 0 to 15
		pdf:Textcolor( GRA_CLR_BLACK )
		pdf:rtext(58.5,6.5+(i*4.5),cores[i+1],65)
		pdf:boxcolor(1,i)
		pdf:box(60,5+(i*4.5),62,8+(i*4.5))
	next

//////////////////////////////   PAGE 4   //////////////////////////////////

	pdf:NewPage(,,75,110)

	pdf:Textcolor( GRA_CLR_BLUE )
	pg3 := pdf:OutLine( 0, , "Charts Demo" )
	pdf:OutLine( 0, pg3, "Pie Chart" )
	pdf:Font('12.Courier New Bold')
	pdf:Text(0.5,2,"Pie Chart Sample")
	pdf:Font('10.Courier New')
	pdf:Text(2,2,"Test Data is      : data := {5,6,1,3,8,9,4,6,1,7}")
	pdf:Text(3,2,"Column titles are : titl := {'1','22','333','4444','55555','666666','7777777','8888888','99999','000'}" )
	pdf:Text(4,2,"Function call is  : PDF:PieChart(40, 10, 8, data, titl, 'Pie Chart Sample' )")
	pdf:Font('10.Courier New',,,,.f.)

	data := {5,6,1,3,8,9,4,6,1,7}
	titu := {'1','22','333','4444','55555','666666','7777777','8888888','99999','000'}
	pdf:PieChart(15,30,5,data,titu,"Pie Chart Sample" )
	
	pdf:Textcolor( GRA_CLR_RED )
	pdf:OutLine( 24, pg3, "Line Chart" )
	pdf:Font('12.Courier New Bold')
	pdf:Text(27.0,2,"Line Chart Sample")
	pdf:Font('10.Courier New')
	pdf:Text(28.5,2,"Test Data is      : data := { {5,6,1,3,8,9,4,6,1,7}, {8,3,7,10,6,8,2,1,3,4} }" )
	pdf:Text(29.5,2,"Column titles are : titl := {'A','B','C','D','E','F','G','H','I','J'}" )
	pdf:Text(30.5,2,"Function call is  : pdf:LineChart(44,10,14,50,data,titl,'Line Chart Sample', {GRA_CLR_BLUE,GRA_CLR_RED} )" )

	data := { {5,6,1,3,8,9,4,6,1,7}, {8,3,7,10,6,8,2,1,3,4} }
	titu := {'A','B','C','D','E','F','G','H','I','J'}
	pdf:LineChart(44,10,14,50,data,titu,"Line Chart Sample", {GRA_CLR_BLUE,GRA_CLR_RED} )

	pdf:Textcolor( GRA_CLR_BLACK )
	pdf:OutLine( 45, pg3, "Bar Chart" )
	pdf:Font('12.Courier New Bold')
	pdf:Text(51.0,2,"Bar Chart Sample")
	pdf:Font('10.Courier New')
	pdf:Text(52.5,2,"Test Data is      : data := {5,6,0,3,8,9,4,6,1,7}")
	pdf:Text(53.5,2,"Column titles are : titl := {'A','B','C','D','E','F','G','H','I','J'}")
	pdf:Text(54.5,2,"Function call is  : PDF:BarChart(40, 10, 25, 55, data, titl, 'Bar Chart Sample', GRA_CLR_BLUE, GRA_CLR_YELLOW)")

	data := {10500,10600,10000,10300,10850,10900,10400,10600,10100,10700}
	titu := {'A','B','C','D','E','F','G','H','I','J'}
	pdf:BarChart(68,10,14,55,data,titu,"Bar Chart Sample",GRA_CLR_BLUE,GRA_CLR_YELLOW)

	a := pdf:numpages()
	for i = 1 to a
		pdf:gotopage(i)
		pdf:font('22.Arial')
		pdf:text(0,38,str(i,2) + ' / ' + alltrim(str(a,3)) )
	next

	pdf:enddoc(.f.)
	pdf:View( fl, -1 )
	close data
	pdf:Destroy()
		
RETURN


FUNCTION XbpPDFKey
return("234234234234234")
